Index: src/document.c
===================================================================
--- src/document.c	(revision 5949)
+++ src/document.c	(working copy)
@@ -3044,7 +3044,7 @@
  * @warning The arguments take the address of each document pointer.
  * @return Negative value if a < b; zero if a = b; positive value if a > b.
  *
- * @since 0.21
+ * @since 1.21
  */
 gint document_compare_by_display_name(gconstpointer a, gconstpointer b)
 {
@@ -3073,7 +3073,7 @@
  * @warning The arguments take the address of each document pointer.
  * @return Negative value if a < b; zero if a = b; positive value if a > b.
  *
- * @since 0.21 (GEANY_API_VERSION 209)
+ * @since 1.21 (GEANY_API_VERSION 209)
  */
 gint document_compare_by_tab_order(gconstpointer a, gconstpointer b)
 {
@@ -3102,7 +3102,7 @@
  * @warning The arguments take the address of each document pointer.
  * @return Negative value if a < b; zero if a = b; positive value if a > b.
  *
- * @since 0.21 (GEANY_API_VERSION 209)
+ * @since 1.21 (GEANY_API_VERSION 209)
  */
 gint document_compare_by_tab_order_reverse(gconstpointer a, gconstpointer b)
 {
Index: src/pluginutils.c
===================================================================
--- src/pluginutils.c	(revision 5949)
+++ src/pluginutils.c	(working copy)
@@ -212,7 +212,7 @@
  *   directly if you want to manage this event source manually).
  *
  * @see g_timeout_add()
- * @since 0.21, plugin API 205.
+ * @since 1.21, plugin API 205.
  */
 guint plugin_timeout_add(GeanyPlugin *plugin, guint interval, GSourceFunc function, gpointer data)
 {
@@ -231,7 +231,7 @@
  *   g_timeout_add_seconds() directly if you want to manage this event source manually).
  *
  * @see g_timeout_add_seconds()
- * @since 0.21, plugin API 205.
+ * @since 1.21, plugin API 205.
  */
 guint plugin_timeout_add_seconds(GeanyPlugin *plugin, guint interval, GSourceFunc function,
 		gpointer data)
@@ -250,7 +250,7 @@
  *   directly if you want to manage this event source manually).
  *
  * @see g_idle_add()
- * @since 0.21, plugin API 205.
+ * @since 1.21, plugin API 205.
  */
 guint plugin_idle_add(GeanyPlugin *plugin, GSourceFunc function, gpointer data)
 {
Index: src/ui_utils.c
===================================================================
--- src/ui_utils.c	(revision 5949)
+++ src/ui_utils.c	(working copy)
@@ -2208,7 +2208,7 @@
  * @param text The text for the tooltip.
  *
  * @since 0.16
- * @deprecated 0.21 use gtk_widget_set_tooltip_text() instead
+ * @deprecated 1.21 use gtk_widget_set_tooltip_text() instead
  */
 void ui_widget_set_tooltip_text(GtkWidget *widget, const gchar *text)
 {
@@ -2415,7 +2415,7 @@
  * the corresponding document pointer as @c user_data.
  * @param compare_func is used to sort the list. Might be @c NULL to not sort the list.
  * @warning You should check @c doc->is_valid in the callback.
- * @since 0.21 */
+ * @since 1.21 */
 void ui_menu_add_document_items_sorted(GtkMenu *menu, GeanyDocument *active,
 	GCallback callback, GCompareFunc compare_func)
 {
Index: geany.nsi
===================================================================
--- geany.nsi	(revision 5949)
+++ geany.nsi	(working copy)
@@ -33,8 +33,8 @@
 ; helper defines  ;
 ;;;;;;;;;;;;;;;;;;;
 !define PRODUCT_NAME "Geany"
-!define PRODUCT_VERSION "0.21"
-!define PRODUCT_VERSION_ID "0.21.0.0"
+!define PRODUCT_VERSION "1.21"
+!define PRODUCT_VERSION_ID "1.21.0.0"
 !define PRODUCT_PUBLISHER "The Geany developer team"
 !define PRODUCT_WEB_SITE "http://www.geany.org/"
 !define PRODUCT_DIR_REGKEY "Software\Geany"
Index: win32-config.h
===================================================================
--- win32-config.h	(revision 5949)
+++ win32-config.h	(working copy)
@@ -314,7 +314,7 @@
 /* #undef volatile */
 
 /* Version number of package */
-#define VERSION "0.21"
+#define VERSION "1.21"
 
 #define REVISION "-1"
 
Index: configure.ac
===================================================================
--- configure.ac	(revision 5949)
+++ configure.ac	(working copy)
@@ -2,7 +2,7 @@
 dnl $Id$
 
 AC_INIT(configure.ac)
-AM_INIT_AUTOMAKE(geany, 0.21)
+AM_INIT_AUTOMAKE(geany, 1.21)
 AC_CONFIG_MACRO_DIR([m4])
 
 m4_ifdef([AM_SILENT_RULES],[AM_SILENT_RULES([yes])])
Index: doc/pluginsignals.c
===================================================================
--- doc/pluginsignals.c	(revision 5949)
+++ doc/pluginsignals.c	(working copy)
@@ -84,7 +84,7 @@
  *  @param doc the re-opened document.
  *  @param user_data user data.
  *
- *  @since 0.21
+ *  @since 1.21
  */
 signal void (*document_reload)(GObject *obj, GeanyDocument *doc, gpointer user_data);
 
Index: doc/geany.txt
===================================================================
--- doc/geany.txt	(revision 5949)
+++ doc/geany.txt	(working copy)
@@ -1,4 +1,4 @@
-.. |(version)| replace:: 0.21
+.. |(version)| replace:: 1.21
 
 =======
  Geany
Index: NEWS
===================================================================
--- NEWS	(revision 5949)
+++ NEWS	(working copy)
@@ -1,4 +1,4 @@
-Geany 0.21 (unreleased)
+Geany 1.21 (unreleased)
 
     General
     * Bump dependencies to GTK >= 2.12, GLib >= 2.16 and GIO.
Index: wscript
===================================================================
--- wscript	(revision 5949)
+++ wscript	(working copy)
@@ -52,7 +52,7 @@
 
 
 APPNAME = 'geany'
-VERSION = '0.21'
+VERSION = '1.21'
 LINGUAS_FILE = 'po/LINGUAS'
 
 top = '.'
Index: geany_private.rc
===================================================================
--- geany_private.rc	(revision 5949)
+++ geany_private.rc	(working copy)
@@ -1,8 +1,8 @@
 
 #include <windows.h> // include for version info constants
 
-#define VER_FILEVERSION             0,21,0,0
-#define VER_FILEVERSION_STR         "0.21"
+#define VER_FILEVERSION             1,21,0,0
+#define VER_FILEVERSION_STR         "1.21"
 
 A ICON MOVEABLE PURE LOADONCALL DISCARDABLE "../icons/geany.ico"
 